// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at https://mozilla.org/MPL/2.0/.
form(nz-form, [formGroup]="form")
  h2 Dynamic outputs
  p Dynamic outputs will be use to generate a HTTP Form or an JSON API. The provided outputs can be linked to the next action's inputs.
  button(nz-button, nzType="primary", (click)="addOutput()")
    span(nz-icon, nzType="plus", nzTheme="outline")
    | Add Dynamic Output
  nz-form-item(*ngFor="let output of config; trackBy:customTrackBy", [formGroupName]="output.id")
    nz-card
      button.ryax-delete-card(nz-button, nzType="primary", nzDanger, (click)="removeOutput(output.id)")
        i(nz-icon, nzType="delete", nzTheme="outline")
      nz-form-label([nzFor]="output.name")
        span Name
      nz-form-control
        input(nz-input, type="text", formControlName="name", placeholder="Input Name")
      p Name of the variable
      nz-form-label([nzFor]="output.help")
        span Help
      nz-form-control
        input(nz-input, type="text", formControlName="help", placeholder="Input Help")
      p Help to explain what this variable contains or should be filled
      ng-container(*ngIf="originRequired")
        nz-form-label([nzFor]="output.origin")
          span Origin
        nz-form-control
          nz-select(formControlName="origin", nzPlaceHolder="Input Origin")
            nz-option(*ngFor="let origin of originList", [nzValue]="origin", [nzLabel]="origin")
        p Where your variable should be extracted from. Using "path" means that the variable name must be available in the templated endpoint
      nz-form-label([nzFor]="output.type")
        span Type
      nz-form-control
        .ryax-type-input
          nz-select(formControlName="type", nzPlaceHolder="Input Type")
            nz-option(*ngFor="let type of outputTypes", [nzValue]="type", [nzLabel]="type")
          ng-container(*ngIf="form.get(output.id + '.type')?.value === 'enum'")
            button(nz-button, nzType="default", (click)="addValue(output.id)") Add Enum Value
        p
          | The type of your variable. See&nbsp;
          a(href="https://docs.ryax.tech/reference/action_python3.html#ryax-types") the documentation
          | &nbsp;for more details
        ng-container(*ngIf="form.get(output.id + '.type')?.value === 'enum'", formArrayName="enumValues")
          .ryax-enum-value(*ngFor="let control of getEnumValuesForm(output.id); let index = index;")
            input(nz-input, type="text", [formControlName]="index" , placeholder="Value")
            button(nz-button, nzType="primary", nzGhost, nzDanger, (click)="removeValue(output.id, index)")
              i(nz-icon, nzType="delete", nzTheme="outline")
      nz-form-label([nzFor]="'optional'")
        span Optional
      nz-form-control
        input(type="checkbox", nz-input, formControlName="optional")
      p If set, this input will be optional and defaults to 'null'
